#include<linux/module.h>
#include<linux/sched/signal.h>

static int __init init_tasklist(void) 
{
	struct task_struct *p;

	for_each_process(p) {
		pr_info("Process name is: %s, and its pid is: %i. ",p->comm, task_pid_nr(p));
		if(p->state==TASK_RUNNING) 
			pr_info("Process state is TASK_RUNNING\n");
		if(p->state==TASK_INTERRUPTIBLE) 
			pr_info("Process state is TASK_INTERRUPTIBLE\n");
		if(p->state==TASK_IDLE) 
			pr_info("Process state is TASK_IDLE\n");
		if(p->state==TASK_UNINTERRUPTIBLE) 
			pr_info("Process state is TASK_UNINTERRUPTIBLE\n");
		if(p->state==TASK_STOPPED) 
			pr_info("Proces state is TASK_STOPPED\n");
	}
	return 0;
}

static void __exit exit_tasklist(void) {

	struct task_struct *p;

	for_each_process(p) {
		pr_info("Process name is: %s, and its pid is: %i. ",p->comm, task_pid_nr(p));
		if(p->state==TASK_RUNNING) 
			pr_info("Process state is TASK_RUNNING.\n");
		if(p->state==TASK_INTERRUPTIBLE) 
			pr_info("Process state is TASK_INTERRUPTIBLE.\n");
		if(p->state==TASK_IDLE) 
			pr_info("Process state is TASK_IDLE\n");
		if(p->state==TASK_UNINTERRUPTIBLE) 
			pr_info("Process state is TASK_UNINTERRUPTIBLE.\n");
		if(p->state==TASK_STOPPED) 
			pr_info("Proces state is TASK_STOPPED.\n");
	}
}

module_init(init_tasklist);
module_exit(exit_tasklist);

MODULE_LICENSE("GPL");
MODULE_DESCRIPTION("Simple module that prints name, pid and state of every running process.");
MODULE_AUTHOR("Arkadiusz Chrobot <a.chrobot@tu.kielce.pl>");
MODULE_VERSION("1.0");

